﻿;https://www.purebasic.fr/english/viewtopic.php?f=13&t=64688

Procedure RGBtoLum(c.l)  ;Get luminosity (the min and max RGB levels / 2)
  r = (c & $FF) :  g = ((c & $FF00) >> 8) :  b = ((c & $FF0000) >> 16) 
  If g < r: min = g: Else: min = r: EndIf
  If b < min: min = b: EndIf  
  If g > r: max = g: Else: max = r: EndIf
  If b > max: max = b: EndIf   
  lum = (max + min) >> 1  ;/ 2.0
  ProcedureReturn lum
EndProcedure

; 1    *     1    1       (1/8)    <- looking at this it doesnt seem to propagate the full error (like Atkinson), but looking at the code it does add "+3" twice, so maybe it does. And interestingly it modifies a PRIOR pixel! Anyway im confused!
Procedure Do1D(hImg)
  Protected nextpixel.f, ierror.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg) 
  Protected error.f         ;hold error for current pixel
  Dim error_arr.f(width)  
  For y = 2 To height-3
    For x = 2 To width-3
      val = RGBtoLum(Point(x,y)) + error_arr(x+1)
      If val > 128
        Plot(x,y,#White)       ;
        error = val-255
      Else
        Plot(x,y,#Black)
        error = val
      EndIf      
      error_arr(x-1) = error_arr(x-1)+(error/8)
      error_arr(x)   = error_arr(x)+3*(error/8)
      error_arr(x+1) = (error/8)
      error_arr(x+2) = error_arr(x+2)+3*(error/8)
    Next x
  Next y
  StopDrawing()
EndProcedure


UsePNGImageEncoder()
UseJPEGImageDecoder()

LoadImage(0,"girl.jpg")
Do1D(0)
SaveImage(0,"atk.png",#PB_ImagePlugin_PNG)
; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = -
; EnableUnicode
; EnableXP