﻿UseJPEGImageDecoder()
UsePNGImageEncoder()
UsePNGImageDecoder()

Global Dim palette.l(8)
palette(0)=RGB(0, 0, 0)
palette(1)=RGB(255, 0, 0)
palette(2)=RGB(0, 255, 0)
palette(3)=RGB(0, 0, 255)
palette(4)=RGB(255, 255, 0)
palette(5)=RGB(255, 0, 255)
palette(6)=RGB(0, 255, 255)
palette(7)=RGB(255, 255, 255)


Procedure.l FindNearestColor(color.l)
  minDistanceSquared.l = 255 * 255 + 255 * 255 + 255 * 255 + 1;
  bestIndex = 0
  For i = 0 To 7
    Rdiff.l = Red(color)-Red(palette(i))
    Gdiff.l = Green(color)-Green(palette(i))
    Bdiff.l = Blue(color)-Blue(palette(i))
    distanceSquared.l = Rdiff * Rdiff + Gdiff * Gdiff + Bdiff * Bdiff;
    If distanceSquared < minDistanceSquared
      minDistanceSquared = distanceSquared;
      bestIndex = i                       ;
    EndIf
  Next i
  If palette(bestIndex)=$FFFFFF
    pp.l=-1
  Else
    pp=palette(bestIndex)
  EndIf
  ProcedureReturn pp
EndProcedure

Procedure.a PlusTruncate(a.a, b.l)
  
  If (a&255)+b<0
    ProcedureReturn 0
  ElseIf (a&255)+b>255
    ProcedureReturn 255
  Else
    ProcedureReturn (a + b)&255
  EndIf
EndProcedure


;reduxe pal?
; w=127
; For i=0 To 7
;   r=Red(palette(i))
;   g=Green(palette(i))
;   b=Blue(palette(i))
;   If r:r=w:EndIf
;   If g:g=w:EndIf
;   If b:b=w:EndIf
;   palette(i)=RGB(r,g,b)
; Next i

;LoadImage(0,"girl.jpg")
LoadImage(0,"nature1.jpg")

h=ImageHeight(0)
w=ImageWidth(0)
CreateImage(1,w*2,h)

ww=w
StartDrawing(ImageOutput(1))
DrawImage(ImageID(0),0,0)

For y=0 To h-1
  For x=0 To w-1
    currentPixel.l = Point(x, y)
    bestColor.l = FindNearestColor(currentPixel)
    Box(x+w, y, 1,1,bestColor)
    
    errorR.l = Red(currentPixel)-Red(bestColor)
    errorG.l = Green(currentPixel)-Green(bestColor)
    errorB.l = Blue(currentPixel)-Blue(bestColor)
    If x + 1 < ww
      cp=Point(x + 1, y + 0)
      ;rr_.a=PlusTruncate(Red(Point(x + 1, y + 0)), errorR * 7/16 )
      rr_.a=PlusTruncate(Red(cp), errorR * 7/16 )
      ;gg_.a= PlusTruncate(Green(Point(x + 1, y + 0)), errorG * 7/16)
      gg_.a= PlusTruncate(Green(cp), errorG * 7/16)
      ;bb_.a=PlusTruncate(Blue(Point(x + 1, y + 0)), errorB * 7/16)
      bb_.a=PlusTruncate(Blue(c), errorB * 7/16)
      Box(x + 1, y + 0, 1,1,RGB(rr_,gg_,bb_))
    EndIf
    If y + 1 < h
      If x - 1 > 0
        cp=Point(x - 1, y + 1)
        ;rr_=PlusTruncate(Red(Point(x - 1, y + 1)), errorR * 3/16)
        rr_=PlusTruncate(Red(cp), errorR * 3/16)
        ;gg_= PlusTruncate(Green(Point(x - 1, y + 1)), errorG * 3/16)
        gg_= PlusTruncate(Green(cp), errorG * 3/16)
        ;bb_=PlusTruncate(Blue(Point(x - 1, y + 1)), errorB * 3/16)
        bb_=PlusTruncate(Blue(cp), errorB * 3/16)
        Box(x - 1, y + 1, 1,1,RGB(rr_,gg_,bb_))
      EndIf
      cp=Point(x + 0, y + 1)
      ;rr_=PlusTruncate(Red(Point(x + 0, y + 1)), errorR * 5/16)
      rr_=PlusTruncate(Red(cp), errorR * 5/16)
      ;gg_= PlusTruncate(Green(Point(x + 0, y + 1)), errorG * 5/16)
      gg_= PlusTruncate(Green(cp), errorG * 5/16)
      ;bb_=PlusTruncate(Blue(Point(x + 0, y + 1)), errorB * 5/16)
      bb_=PlusTruncate(Blue(cp), errorB * 5/16)
      Box(x + 0, y + 1, 1,1,RGB(rr_,gg_,bb_))
      If x + 1 < w
        cp=Point(x + 1, y + 1)
        ;rr_=PlusTruncate(Red(Point(x + 1, y + 1)), errorR/16)
        rr_=PlusTruncate(Red(cp), errorR/16)
        ;gg_= PlusTruncate(Green(Point(x + 1, y + 1)), errorG/16)
        gg_= PlusTruncate(Green(cp), errorG/16)
        ;bb_=PlusTruncate(Blue(Point(x + 1, y + 1)), errorB/16)
        bb_=PlusTruncate(Blue(cp), errorB/16)
        Box(x + 1, y + 1, 1,1,RGB(rr_,gg_,bb_))
      EndIf
    EndIf;If y + 1 < h
  Next x
Next y

StopDrawing()

GrabImage(1,2,w,0,w,h)
SaveImage(2,"gg.png",#PB_ImagePlugin_PNG)

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 127
; FirstLine = 87
; Folding = -
; EnableUnicode
; EnableXP