﻿;https://www.purebasic.fr/english/viewtopic.php?t=75708
EnableExplicit


Procedure.i DitherImage(Image.i, Factor.i=1)
  
  Protected.l pix, c
  Protected.i NewImg, x, y, ImgHeight, ImgWidth
  Protected.f oldR, oldG, oldB, errR, errG, errB, newR, newG, newB, r, g, b
  
  If IsImage(Image)
    
    NewImg = CopyImage(image, #PB_Any)
    If NewImg
      
      ; fill array
      If StartDrawing(ImageOutput(NewImg))
        
        ImgHeight = ImageHeight(NewImg) - 2
        ImgWidth = ImageWidth(NewImg) - 2
        
        For y = 0 To ImgHeight
          For x = 1 To ImgWidth
            
            pix = Point(x,y)
            
            oldR = Red(pix)
            oldG = Green(pix)
            oldB = Blue(pix)
            
            newR = Round(oldr * factor / 255.0, #PB_Round_Nearest) * (255.0 / factor)
            newG = Round(oldg * factor / 255.0, #PB_Round_Nearest) * (255.0 / factor)
            newB = Round(oldb * factor / 255.0, #PB_Round_Nearest) * (255.0 / factor)
            
            Plot(x, y, RGB(newR, newG, newB))
            
            errR = oldR - newR
            errG = oldG - newG
            errB = oldB - newB
            
            c = Point(x + 1, y)
            r = Red(c)
            g = Green(c)
            b = Blue(c)
            r = r + errR * 7.0 / 16.0
            g = g + errG * 7.0 / 16.0
            b = b + errB * 7.0 / 16.0
            If r < 0 : r = 0 : ElseIf r > 255 : r = 255 : EndIf
            If g < 0 : g = 0 : ElseIf g > 255 : g = 255 : EndIf
            If b < 0 : b = 0 : ElseIf b > 255 : b = 255 : EndIf
            Plot(x + 1, y, RGB(r, g, b))
            
            c = Point(x - 1, y + 1)
            r = Red(c)
            g = Green(c)
            b = Blue(c)
            r = r + errR * 3.0 / 16.0
            g = g + errG * 3.0 / 16.0
            b = b + errB * 3.0 / 16.0
            If r < 0 : r = 0 : ElseIf r > 255 : r = 255 : EndIf
            If g < 0 : g = 0 : ElseIf g > 255 : g = 255 : EndIf
            If b < 0 : b = 0 : ElseIf b > 255 : b = 255 : EndIf
            Plot(x - 1, y + 1, RGB(r, g, b))
            
            c = Point(x, y + 1)
            r = Red(c)
            g = Green(c)
            b = Blue(c)
            r = r + errr * 5.0 / 16.0
            g = g + errg * 5.0 / 16.0
            b = b + errb * 5.0 / 16.0
            If r < 0 : r = 0 : ElseIf r > 255 : r = 255 : EndIf
            If g < 0 : g = 0 : ElseIf g > 255 : g = 255 : EndIf
            If b < 0 : b = 0 : ElseIf b > 255 : b = 255 : EndIf
            Plot(x, y + 1, RGB(r, g, b))
            
            c = Point(x + 1, y + 1)
            r = Red(c)
            g = Green(c)
            b = Blue(c)
            r = r + errr * 1.0 / 16.0
            g = g + errg * 1.0 / 16.0
            b = b + errb * 1.0 / 16.0
            If r < 0 : r = 0 : ElseIf r > 255 : r = 255 : EndIf
            If g < 0 : g = 0 : ElseIf g > 255 : g = 255 : EndIf
            If b < 0 : b = 0 : ElseIf b > 255 : b = 255 : EndIf
            Plot(x + 1, y + 1, RGB(r, g, b))
            
          Next
        Next
        
        StopDrawing()
      EndIf
      
    EndIf
  EndIf
  
  ProcedureReturn NewImg
  
EndProcedure


Define.i Image, DitheredImg

UseJPEGImageDecoder()

Image = LoadImage(#PB_Any, "girl.jpg")

OpenWindow(0, 0, 0, ImageWidth(image) * 2, ImageHeight(image), "Demo", #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
ImageGadget(0, 0, 0, 0, 0, ImageID(image))
ImageGadget(1, ImageWidth(image), 0, 0, 0, 0)

DitheredImg = DitherImage(image)
If DitheredImg
  SetGadgetState(1, ImageID(DitheredImg))
EndIf

Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 106
; FirstLine = 78
; Folding = -
; EnableUnicode
; EnableXP