﻿;https://www.purebasic.fr/english/viewtopic.php?f=13&t=64688
;Jarvis-Judice-Ninke:
;             X   7   5         
;     3   5   7   5   3   (1/48)
;     1   3   5   3   1 

#PBBlack = $000000:   #PBWhite = $FFFFFF

Procedure.i TruncF0255 (a.f)
  If a > 255: a = 255: ElseIf a < 0: a = 0: EndIf
  ProcedureReturn a
EndProcedure

Procedure RGBtoLum(c.l)  ;Get luminosity (the min and max RGB levels / 2)
  r = (c & $FF) :  g = ((c & $FF00) >> 8) :  b = ((c & $FF0000) >> 16) 
  If g < r: min = g: Else: min = r: EndIf
  If b < min: min = b: EndIf  
  If g > r: max = g: Else: max = r: EndIf
  If b > max: max = b: EndIf   
  lum = (max + min) >> 1  ;/ 2.0
  ProcedureReturn lum
EndProcedure

Procedure JarvisJudiceNinkeDIRECT(hImg)
  Protected nextpixel.f, ierror.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg)
  For y = 3 To height-4
    For x = 3 To width-4
      oldpixel = RGBtoLum(Point(x,y))
      If oldpixel < 128
        newpixel = 0
        Plot(x,y, #Black)
      Else
        newpixel = 255
        Plot(x,y, #White)
      EndIf
      quant_error.f = oldpixel - newpixel
      newx.f = TruncF0255(RGBtoLum(Point(x+1,y))     + ((7/48) * quant_error))
      Plot(x+1,y, RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x+2,y))     + ((5/48) * quant_error))
      Plot(x+2,y, RGB(newx,newx,newx))
      
      newx.f = TruncF0255(RGBtoLum(Point(x-2,y+1))   + ((3/48) * quant_error))
      Plot(x-2,y+1,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x-1,y+1))   + ((5/48) * quant_error))
      Plot(x-1,y+1,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x,  y+1))   + ((7/48) * quant_error))
      Plot(x,  y+1,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x+1,y+1))   + ((5/48) * quant_error))
      Plot(x+1,y+1,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x+2,y+1))   + ((3/48) * quant_error))
      Plot(x+2,y+1,  RGB(newx,newx,newx))
      
      newx.f = TruncF0255(RGBtoLum(Point(x-2,y+2))   + ((1/48) * quant_error))
      Plot(x-2,y+2,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x-1,y+2))   + ((3/48) * quant_error))
      Plot(x-1,y+2,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x,  y+2))   + ((5/48) * quant_error))
      Plot(x,  y+2,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x+1,y+2))   + ((3/48) * quant_error))
      Plot(x+1,y+2,  RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x+2,y+2))   + ((1/48) * quant_error))
      Plot(x+2,y+2,  RGB(newx,newx,newx))      
    Next x
  Next y
  StopDrawing()
EndProcedure


Procedure JarvisJudiceNinkeARRAY(hImg)
  Protected nextpixel.f, oldpixel.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg)
  Dim error.f(width+5,height+5)  ;An error(x,y) for every pixel
  For y = 3 To height-4
    For x = 3 To width-4
      oldpixel = Truncf0255(RGBtoLum(Point(x,y)) + error(x,y)) 
      If oldpixel < 128
        newpixel = 0
        Plot(x,y, #PBBlack)
      Else
        newpixel = 255
        Plot(x,y, #PBWhite)
      EndIf      
      quant_error.f = oldpixel - newpixel
      error(x+1,y)   + ((7/48) * quant_error)
      error(x+2,y)   + ((5/48) * quant_error)
      
      error(x-2,y+1) + ((3/48) * quant_error)
      error(x-1,y+1) + ((5/48) * quant_error)
      error(x,  y+1) + ((7/48) * quant_error)
      error(x+1,y+1) + ((5/48) * quant_error)
      error(x+2,y+1) + ((3/48) * quant_error)
      
      error(x-2,y+2) + ((1/48) * quant_error)
      error(x-1,y+2) + ((3/48) * quant_error)
      error(x,  y+2) + ((5/48) * quant_error)
      error(x+1,y+2) + ((3/48) * quant_error)
      error(x+2,y+2) + ((1/48) * quant_error)      
    Next x
  Next y
  StopDrawing()
EndProcedure

UsePNGImageEncoder()
UseJPEGImageDecoder()

LoadImage(0,"girl.jpg")
JarvisJudiceNinkeARRAY(0)
SaveImage(0,"jar.png",#PB_ImagePlugin_PNG)
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP