﻿;https://www.purebasic.fr/english/viewtopic.php?f=13&t=64688

Procedure RGBtoLum(c.l)  ;Get luminosity (the min and max RGB levels / 2)
  r = (c & $FF) :  g = ((c & $FF00) >> 8) :  b = ((c & $FF0000) >> 16) 
  If g < r: min = g: Else: min = r: EndIf
  If b < min: min = b: EndIf  
  If g > r: max = g: Else: max = r: EndIf
  If b > max: max = b: EndIf   
  lum = (max + min) >> 1  ;/ 2.0
  ProcedureReturn lum
EndProcedure

Procedure.i TruncF0255 (a.f)
  If a > 255: a = 255: ElseIf a < 0: a = 0: EndIf
  ProcedureReturn a
EndProcedure
;            *    1               
;        1   3    3       (1/8)       <- my best guess
Procedure DoOmohundro(hImg)
  Protected nextpixel.f, ierror.f, fer.f, eer.f, teer.f, lr.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg)  
  Protected error.f         ;hold error for current pixel
  Dim error_arr.f(width)  
  For y = 2 To height-3
    lr = 0
    For x = 2 To width-3      
      val = TruncF0255(RGBtoLum(Point(x,y)) + error_arr(x)) 
      If val > 128        
        Plot(x,y,#White)     
        error = val-255
      Else
        Plot(x,y,#Black) 
        error = val
      EndIf            
      fer.f = error/4     ;a fourth of the error
      eer.f = fer/2       ;an eighth
      teer.f = fer + eer  ;three eights
      error_arr(x-1) + eer
      error_arr(x) = teer + lr
      lr = eer
      error_arr(x+1) + teer
    Next x
  Next y
  StopDrawing()
EndProcedure


UsePNGImageEncoder()
UseJPEGImageDecoder()

LoadImage(0,"girl.jpg")
DoOmohundro(0)
SaveImage(0,"omo.png",#PB_ImagePlugin_PNG)
; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = -
; EnableUnicode
; EnableXP